Subject: source and dst addr for Neighbor Solicitation

From: Vijay Devarapalli <[email-masked]>
Date: Wed, 06 Mar 2002 19:17:30 -0800

hi,

A simple question. When would you ever use global source
and destination addresses for a neighbor solicitation. 
And why?

IMO, link local addresses must be used. But RFC 2461 does 
not say this. It just says an address configured to the 
interface. That can mean global addresses. I saw such a
packet at Connectathon (going on in San Jose).

Vijay
--------------------------------------------------------------------
IETF IPng Working Group Mailing List
IPng Home Page:                      http://playground.sun.com/ipng
FTP archive:                      ftp://playground.sun.com/pub/ipng
Direct all administrative requests to [email-masked]
--------------------------------------------------------------------

---

From: Francis Dupont <[email-masked]>
Date: Thu, 07 Mar 2002 10:34:12 +0100

In your previous mail you wrote:

=> there is no real constraint on addresses, only some special
cases (unspecified source and multicast destination). This keeps
the door open for some optimizations.

   And why?
   
=> if the two neighbors initiate a direct communication using
global addresses, to use global addresses in neighbor solicitation
avoid to create context (aka neighbor cache entries) for both
global addresses and link-local addresses.

   IMO, link local addresses must be used.

=> please don't shut doors on our fingers (:-)...

   But RFC 2461 does not say this. It just says an address configured
   to the interface. That can mean global addresses. I saw such a
   packet at Connectathon (going on in San Jose).
   
=> yes, local traffic usually is with global addresses in NSs,
not local one uses nearly always link-locals because routers are
known by their link-local addresses (some implementations even enforce
link-local addresses in the gateway field of routes).

Regards

[email-masked]

---

From: Erik Nordmark <[email-masked]>
Date: Thu, 7 Mar 2002 16:11:44 +0100 (CET)

> and destination addresses for a neighbor solicitation. 

For an NS it makes sense to use an IP source address that the peer will
try to send packets to so that the NS (with a source link-layer address
option) can create/update the neighbor cache entry on the peer.
If you don't do this you'll end up with twice the number of ND packets
as in
	A  ---> NS --> B
	A <---  NA <-- B
A now has NCE for B
	A ---> TCP --> B	When B wants to respond it doesn't have a
				NCE for A
	A <---  NS <-- B
	A  ---> NA --> B
B now has NCE for A		
	A <--  TCP <-- B

Also, for NUD you want to probe the actual destination in the NCE by
sending to that unicast address. Thus the destination in a unicast NS
should be a global address if the NCE is for a global address.
	
> packet at Connectathon (going on in San Jose).

RFC 2461 should say something consistent with the above somewhere.
E.g section 7.2.2 and reading between the lines in 7.3.3+4.3.
Any suggestions on how it can be made more clear?

  Erik